src/k9/routes/web.php
<?php

use App\Http\Controllers\Auth\NewPasswordController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\ApprentiController;
use App\Http\Controllers\BackendController;
use App\Http\Controllers\OffreController;
use App\Http\Controllers\EntrepriseController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\AptitudeController;
use App\Http\Controllers\BulletinController;
use App\Http\Controllers\OptionController;
use App\Http\Controllers\PromotionController;
use App\Http\Controllers\PromotionEleveController;
use App\Http\Controllers\EntretienController;
use App\Http\Controllers\ProfesseurController;
use App\Http\Controllers\FicheController;
use App\Http\Controllers\MatiereController;
use App\Http\Controllers\NoteController;
use App\Http\Controllers\OffreEntreprise;
use App\Http\Controllers\PeriodeController;
use App\Http\Controllers\RdController;
use App\Http\Controllers\TuteurController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/first-password/{token}', [NewPasswordController::class, 'first'])->name('password.first');
    
// Groupe de routes avec uniquement le middleware d'authentification (connecté au site) //
Route::middleware(['auth', 'firstlogin'])->group(function () {
    Route::get('/mentions', [BackendController::class, 'mentions'])->name('mentions');
    Route::get('/', [OffreController::class, 'welcome'])->name('welcome');
    Route::get('profil', [UserController::class, 'profil'])->name('profil');
    Route::post('profil', [UserController::class, 'profilUpdate'])->name('profilUpdate');
    Route::resource('offre_entreprise', OffreEntreprise::class);
});
// Groupe de routes pour les professeurs avec middelware
Route::middleware(['auth', 'firstlogin', 'professeur'])->prefix('professeur')->group(function () {
    Route::get('/', [BackendController::class, 'profDashboard'])->name('profdashboard');
    Route::get('/matiereProfesseur', [MatiereController::class, 'matiereProfesseur'])->name('matiereProfesseur');
    Route::get('/promotionProfesseur', [PromotionController::class, 'promotionProfesseur'])->name('promotionProfesseur');
    Route::resource('notes', NoteController::class)->except(['show']);
    Route::get('notes/create/matieres/{promotion_id}', [NoteController::class, 'createMatieres'])->name('notes.create.matieres');
    Route::get('notes/create/apprentis/{promotion_id}', [NoteController::class, 'createApprentis'])->name('notes.create.apprentis');
    Route::get('notes/create/periodes/{promotion_id}', [NoteController::class, 'createPeriodes'])->name('notes.create.periodes');
});
// Groupe de routes avec le middleware d'authentification et celui d'admin du site //
Route::middleware(['auth','admin', 'firstlogin'])->group(function () {
    Route::get('fiche/pdf', [FicheController::class, 'testViewPDF'])->name('testViewPDF');
    Route::get('fiche/export/{id}', [FicheController::class, 'getPostPdf'])->name('getPostPdf');
    Route::post('/tuteur_entreprise', [OffreController::class, 'tuteurEntreprise'])->name('tuteur_entreprise');
    Route::post('/download', [BackendController::class, 'download'])->name('download');
    Route::post('/contact', [BackendController::class, 'contact'])->name('contact');
    /* Changer ces routes dans le rd */
    Route::post('/promotionPeriode', [PeriodeController::class, 'promotionPeriode'])->name('promotionPeriode');
    Route::post('/promotionApprenti', [PromotionController::class, 'promotionApprenti'])->name('promotionApprenti');
    Route::get('/bulletinPromotion', [BulletinController::class, 'bulletinPromotion'])->name('bulletinPromotion');
    Route::post('/bulletinMatiere', [BulletinController::class, 'bulletinMatiere'])->name('bulletinMatiere');
    Route::post('/promotionMatiere',[PromotionController::class, 'promotionMatiere'])->name('promotionMatiere');
    /* */
    Route::prefix('admin')->group(function () {
        Route::resource('aptitudes', AptitudeController::class);
        Route::resource('offres', OffreController::class);
        Route::resource('entreprises', EntrepriseController::class);
        Route::resource('tuteurs', TuteurController::class);
        Route::resource('users', UserController::class);
        Route::resource('options', OptionController::class);
        Route::resource('promotions', PromotionController::class);
        Route::resource('apprenti', ApprentiController::class);
        Route::resource('eleve_promotion', PromotionEleveController::class);
        Route::resource('entretiens', EntretienController::class);
        Route::resource('professeur', ProfesseurController::class);
        Route::resource('fiches', FicheController::class);
        Route::resource('rd', RdController::class);
        Route::resource('matieres',MatiereController::class);
        Route::resource('periodes',PeriodeController::class);
        // A changer dans rd
        Route::resource('bulletins',BulletinController::class);
        Route::get('/', [BackendController::class, 'dashboard'])->name('dashboard');
    });
});
require __DIR__ . '/auth.php';

src/k9/app/Models/Tuteur.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Tuteur extends Model
{
    use HasFactory;
    protected $guarded = [];

    public function user() 
    { 
        return $this->morphOne(User::class, 'profil');
    }

    public function entreprise()
    {
        return $this->belongsTo(Entreprise::class);
    }

    public function apprentis()
    {
        return $this->belongsToMany(Apprenti::class)->withPivot('date_debut','date_fin');
    }

    public function offres()
    {
        return $this->hasMany(Offre::class);
    }
}

src/k9/app/Http/Controllers/TuteurController.php
<?php

namespace App\Http\Controllers;

use App\Models\Apprenti;
use App\Models\Entreprise;
use App\Models\Tuteur;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Str;

class TuteurController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $tuteurs = Tuteur::all();
        return view('tuteurs.index', compact('tuteurs'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $entreprises = Entreprise::all();
        $apprentis = Apprenti::all();
        return view('tuteurs.edit', compact('entreprises','apprentis'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $data = $request->validate([
            'nom' => 'required',
            'prenom' => 'required',
            'email' => 'required|email',
            'telephone' => array('required','size:10','regex:/^((\+)33|0)[1-9](\d{2}){4}$/'),
            'entreprise_id' => 'required',
            'apprenti_id' => 'numeric|nullable',
            'apprenti_debut' => 'requiredif:apprenti_id,!=,nullable|date_format:Y-m-d|after:yesterday|nullable',
            'apprenti_fin' => 'date_format:Y-m-d|after:date_debut|nullable',
        ]);
        $tuteurData = [
            "telephone"=>$data["telephone"],
            "entreprise_id"=>$data[ "entreprise_id"]
        ];
        $t = Tuteur::create($tuteurData);
        $userData = [
            "nom" => $data["nom"],
            "prenom" => $data["prenom"],
            "email" => $data["email"],
            
            "password"=> Hash::make(Str::random(20)),
        ];
        $u = User::create($userData);
        $t->user()->save($u);
        $t->apprentis()->attach($data['apprenti_id'], ['date_debut' => $data['apprenti_debut'], 'date_fin' => $data['apprenti_fin']]);
        $t->save();

        $user = new User;
        $user->nom = $request->input('nom');
        $user->prenom = $request->input('nom');
        $user->email = $request->input('email');
        $user->password = $request->input('password');
        // $user->password = Hash::make('password', [
        //     'rounds' => 12,
        // ]);
        $user->save();

        $tuteur = new Tuteur;
        $tuteur->telephone = $request->input('telephone');
        $tuteur->entreprise = $request->input('entreprise_id');
        $tuteur->save();
        // $tuteurData = [
        //     "telephone"=>$data["telephone"],
        //     "entreprise_id"=>$data[ "entreprise_id"]
        // ];
        // $t = Tuteur::create($tuteurData);
        // $userData = [
        //     "nom" => $data["nom"],
        //     "prenom" => $data["prenom"],
        //     "email" => $data["email"],
        //     "password" => $data["password"]
        // ];
        // $u = User::create($userData);
        // $t->user()->save($u);
        // $t->apprentis()->attach($data['apprenti_id'], ['date_debut' => $data['apprenti_debut'], 'date_fin' => $data['apprenti_fin']]);
        // $t->save();

        return redirect()->route('tuteurs.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $tuteur = Tuteur::find($id);
        return view('tuteurs.show', compact('tuteur'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $tuteur = Tuteur::find($id);
        $entreprises = Entreprise::all();
        $apprentis = Apprenti::all();
        $tuteurApprentis = $tuteur->apprentis->sortby('date_debut');
        $tuteurApprentis = $tuteurApprentis->all();
        return view('tuteurs.edit', compact('entreprises','tuteur','apprentis', 'tuteurApprentis'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $data = $request->validate([
            'nom' => 'required',
            'prenom' => 'required',
            'email' => 'required|email',
            'telephone' => array('required', 'size:10', 'regex:/^((\+)33|0)[1-9](\d{2}){4}$/'),
            'entreprise_id' => 'required',
            'apprenti_id' => 'numeric|nullable',
            'apprenti_debut' => 'requiredif:apprenti_id,!=,null|date|nullable',
            'apprenti_fin' => 'date|nullable',
        ]);
        $t = Tuteur::find($id);
        $t->user->nom = $data["nom"];
        $t->user->prenom = $data["prenom"];
        $t->user->email = $data["email"];
        $t->telephone = $data["telephone"];
        $t->entreprise_id = $data["entreprise_id"];
        $t->apprentis()->attach($data['apprenti_id'],['date_debut'=>$data['apprenti_debut'], 'date_fin' => $data['apprenti_fin']]);
        $t->save();

        return redirect()->route('tuteurs.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $tuteur = Tuteur::find($id);
        $tuteur->delete();
        return redirect()->route('tuteurs.index');
    }
}

src/k9/resources/views/tuteurs/edit.blade.php
@extends('backend.template')

@section('content')
    <div class="row">
        <div class="col-lg-12 margin-tb">
            <div class="float-start">
                <h2>{{ !empty($tuteur) ? 'Modifier' : 'Créer' }} un tuteur</h2>
            </div>
            <div class="float-end">
                <a class="btn btn-outline-primary" href="{{ route('tuteurs.index') }}">Retour</a>
            </div>
        </div>
    </div>

    @if ($errors->any())
        <div class="alert alert-danger">
            Une erreur est survenue..<br>
            <ul>
                @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
    @endif

    @isset($tuteur)
        <form action="{{ route('tuteurs.update', $tuteur) }}" method="POST">
            @method('PUT')
            @else
            <form action="{{ route('tuteurs.store') }}" method="POST">
            @endisset
            @csrf
            <div class="container">
                <div class="row">
                    <div class="col-12">
                        <div class="form-group">
                            <a class="font-bold">Nom:</a>
                            <input type="text" name="nom" class="form-control" placeholder="Dupont"
                                value="{{ !empty($tuteur) ? $tuteur->user->nom : old('nom') }}">
                        </div>
                    </div>
                    <div class="col-12">
                        <div class="form-group">
                            <a class="font-bold">Prénom:</a>
                            <input class="form-control" name="prenom" placeholder="Jean"
                                value="{{ !empty($tuteur) ? $tuteur->user->prenom : old('prenom') }}">
                        </div>
                    </div>
                    <div class="col-12">
                        <div class="form-group">
                            <a class="font-bold">Adresse mail:</a>
                            <input type="text" name="email" id="email" class="form-control"
                                placeholder="JeanDupont@gmail.com"
                                value="{{ !empty($tuteur) ? $tuteur->user->email : old('email') }}">
                        </div>
                    </div>
                    <div class="col-12">
                        <div class="form-group">
                            <a class="font-bold">Téléphone:</a>
                            <input type="text" name="telephone" id="telephone" class="form-control"
                                placeholder="03 81 01 23 45"
                                value="{{ !empty($tuteur) ? $tuteur->telephone : old('telephone') }}">
                        </div>
                    </div>
                    <div class="col-12">
                        <div class="form-group">
                            <a class="font-bold">Entreprise:</a>
                            <select class="form-select" name="entreprise_id" id="entreprise_id">
                                @foreach ($entreprises as $entreprise)
                                    <option value="{{ $entreprise->id }}"
                                        {{ !empty($tuteur) ? ($tuteur->entreprise->id == $entreprise->id ? 'selected' : '') : '' }}>
                                        {{ $entreprise->nom }}</option>
                                @endforeach
                            </select>
                        </div>
                    </div>
                            <div class="col-12">
                                <div class="form-group">
                                    <a class="font-bold">Apprenti:</a>
                                    <select class="form-select" name="apprenti_id" id="apprenti_id">
                                        <option value="" {{ !empty($tuteurApprentis) ? 'selected' : '' }}>Aucun apprenti
                                        </option>
                                        @foreach ($apprentis as $apprenti)
                                            <option value="{{ $apprenti->id }}" @if (!empty($tuteur) && !empty($tuteurApprentis))
                                                @foreach ($tuteurApprentis as $ta)
                                                    @if ($loop->first)
                                                     Selected
                                                    @endif
                                                @endforeach
                                        @endif
                                        >{{ $apprenti->user->nom ." ". $apprenti->user->prenom}}</option>
                                        @endforeach
                                    </select>
                                </div>
                            </div>
                            <div class="col-12 form-row">
                                <div class="col-6">
                                    <div class="form-group">
                                        <a class="font-bold">Date de début :</a>
                                        <input type="date" name="apprenti_debut" id="apprenti_debut" class="form-control"
                                        @if(!empty($tuteurApprentis))
                                                @foreach ($tuteurApprentis as $ta)
                                                    @if ($loop->first)
                                                     value="{{$ta->pivot->date_debut}}"
                                                    @endif
                                                @endforeach
                                        @else
                                        value="{{Carbon\Carbon::now()->format('Y-m-d')}}"
                                        @endif
                                        >
                                    </div>
                                </div>
                                <div class="col-6">
                                    <div class="form-group">
                                        <a class="font-bold">Date de fin:</a>
                                        <input type="date" name="apprenti_fin" id="apprenti_fin" class="form-control"
                                        @if(!empty($tuteurApprentis))
                                                @foreach ($tuteurApprentis as $ta)
                                                    @if ($loop->first)
                                                     value="{{$ta->pivot->date_fin}}"
                                                    @endif
                                                @endforeach
                                        @else
                                        value="{{Carbon\Carbon::now()->format('Y-m-d')}}"
                                        @endif
                                        >
                                    </div>
                                </div>
                    </div>
                    <div class="col-12 text-center">
                        <button type="submit" class="btn btn-primary">Submit</button>
                    </div>
                </div>
            </div>
        </form>
    @endsection

src/k9/resources/views/tuteurs/index.blade.php
@extends('backend.template')

@section('content')
    <div class="row">
        <div class="col-lg-12 margin-tb">
            <div class="float-start">
                <h2>CRUD Tuteurs</h2>
            </div>
            <div class="float-end">
                <a class="btn btn-outline-success" href="{{ route('tuteurs.create') }}">Ajouter une nouveau tuteur</a>
            </div>
        </div>
    </div>

    @if ($message = Session::get('success'))
        <div class="alert alert-success">
            <p>{{ $message }}</p>
        </div>
    @endif
    <div class="padd20">
        <table class="table table-bordered" id="example">
            <thead>
                <th>Prenom</th>
                <th>Nom</th>
                <th>Email</th>
                <th>Tel.</th>
                <th>Entreprise</th>
                <th width="280px">Action</th>
            </thead>
            <tbody>
            @foreach ($tuteurs as $tuteur) 
                <tr>
                  
                    <td>{{ $tuteur->user->prenom }}</td>
                    <td>{{ $tuteur->user->nom }}</td>
                    <td>{{ $tuteur->user->email }}</td>
                    <td>{{ $tuteur->telephone }}</td>
                    <td>
                        <a class="btn" href="{{ route('entreprises.show', $tuteur->entreprise) }}" style="width: auto"> {{ $tuteur->entreprise->nom }}</a>
                    </td>
                    <td class="actions">
                        <a class="btn btn-edit col" href="{{ route('tuteurs.edit', $tuteur) }}"></a>
                        <a class="btn btn-show col" href="{{ route('tuteurs.show', $tuteur) }}"></a>
                             <!-- Button trigger modal -->
                    <button type="button" class="btn btn-delete col" data-bs-toggle="modal" data-bs-target="#{{ "modal-".$tuteur->id}}"></button>
                    
                    <form action="{{ route('tuteurs.destroy',$tuteur) }}" method="POST" >
                        @csrf
                        @method('DELETE')
                    <!-- Modal -->
                    <div class="modal fade" id="{{ "modal-".$tuteur->id}}" tabindex="-1" aria-labelledby="{{ "modalLabel-".$tuteur->id}}" aria-hidden="true">
                      <div class="modal-dialog">
                        <div class="modal-content">
                          <div class="modal-header">
                            <h5 class="modal-title" id="{{ "modalLabel-".$tuteur->id}}">
                                Supression Tuteur</h5>
                            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                          </div>
                          <div class="modal-body">
                            Voulez-vous vraimment supprimer ce tuteur?
                          </div>
                          <div class="modal-footer">
                            <button type="button" class="btn-modal btn-secondary" data-bs-dismiss="modal">Fermer</button>
                            <button type="submit" class="btn-modal btn-primary">Supprimer</button>
                          </div>
                        </div>
                      </div>
                    </div>
                </form>
                    </td>
                </tr>
            @endforeach
            </tbody>
        </table>
    </div>
@endsection

src/k9/resources/views/tuteurs/show.blade.php
@extends('backend.template')
  
@section('content')
    <div class="row">
        <div class="col-lg-12 margin-tb">
            <div class="pull-left">
                <h2>Tuteur</h2>
            </div>
            <div class="pull-right">
                <a class="btn btn-outline-primary" href="{{ route('tuteurs.index') }}">Retour</a>
            </div>
        </div>
    </div>
   
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Nom :</strong>
                {{ $tuteur->user->nom }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Prenom :</strong>
                {{ $tuteur->user->prenom }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Adresse mail :</strong>
                {{ $tuteur->user->email }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Téléphone : </strong>
                {{ $tuteur->telephone }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <strong>Entreprise : </strong>
                {{ $tuteur->entreprise->nom }}
            </div>
        </div>
    </div>
@endsection     